function groups = find_groups(dists, threshold)

  N = size(dists, 1);
  groups = zeros(1, N);

  group_id = 1;

  already_used = zeros(1, N);
  for I=1:N
    if already_used(I), continue; end

    if length(find(dists(I, :) < threshold)) == 0, continue; end
      
    queue = I;
    while ~isempty(queue)
      cur = queue(1);
      queue = queue(2:end);
      
      groups(cur) = group_id;

      new = find(dists(cur, :) < threshold);
      already_used(new) = 1;
      queue = [queue new];

      dists(cur, :) = Inf;
      dists(:, cur) = Inf;
      dists(:, new) = Inf;
    end
    
    group_id = group_id + 1;
  end