function angle = vecangle(v1, v2)
% computes the angle between two vectors
  v1 = v1 / norm(v1);
  v2 = v2 / norm(v2);
  

  angle = atan2(abs(v1(1)*v2(2) - v1(2)*v2(1)), v1(1)*v2(1) + v1(2)*v2(2));
  % is the same as:
  % angle = atan2(norm(cross([v1 0],[v2 0])),dot([v1 0],[v2 0]));
  
  if angle > pi
    angle = angle - pi;
  end
  
  return;
  